/*
 * Ukazka pouziti SortedSet.
 */
package ija.collections.collections;

import java.util.*;

/**
 * Ukazka pouziti SortedSet. Vyuziti generics a for-each loop.
 * @author Radek Koci
 */
public class SortedSetDemo {

    public static void main(String[] args) {
	SortedSet mnozina = new TreeSet();
	MyCorrectPerson c1 = new MyCorrectPerson("Franta");
	MyCorrectPerson c2 = new MyCorrectPerson("Ferda");
	
	mnozina.add(c1);
	mnozina.add(c2);
	
	for (Iterator i = mnozina.iterator(); i.hasNext(); )
	{
	    MyCorrectPerson c = (MyCorrectPerson) i.next();
	    c.vypisInfo();
	}
    }
    
    static private class MyCorrectPerson extends CorrectPerson implements Comparable {

	public MyCorrectPerson(String name) { super(name); }
	
	public int compareTo(Object o) {
	    if (o instanceof MyCorrectPerson) {
		MyCorrectPerson c = (MyCorrectPerson) o;
		return name.compareTo(c.name);
	    } else
		throw new IllegalArgumentException("Nelze porovnat");
	}
	
    }
}
